# plugin which recurses through directories processing
# each file it finds

package RecPlug;

use BasPlug;
use plugin;


BEGIN {
    @ISA = ('BasPlug');
}

sub new {
    my ($class) = @_;
    my $self = new BasPlug ();

    return bless $self, $class;
}

# return 1 if this class might recurse using $pluginfo
sub is_recursive {
    my $self = shift (@_);

    return 1;
}

# return 1 if processed, 0 if not processed
# Note that $base_dir might be "" and that $file might 
# include directories
sub read {
    my $self = shift (@_);
    my ($pluginfo, $base_dir, $file, $metadata, $processor) = @_;


    my (@dir, $subfile);

    # see if this is a directory
    if (-d "$base_dir$file") {

	# read all the files in the directory
	opendir (DIR, "$base_dir$file") ||
	    die "ERROR - couldn't read directory $base_dir$file\n";
	@dir = readdir (DIR);
	closedir (DIR);

	# process each file
	foreach $subfile (@dir) {
	    if ($subfile !~ /^\.\.?$/) {
		# note: metadata is not carried on to the next level
		my $tmp = "$file/$subfile";
		$tmp =~ s/^[\\\/]+|[\\\/]+$//g; # remove extra slashes
		&plugin::read ($pluginfo, $base_dir, $tmp, {}, $processor);
	    }
	}

	return 1;
    }

    # wasn't a directory, someone else will have to process it
    return 0;
}


1;
